clear all
rng(0); % fix random number

% Setting hyperparameters
alpha = 0.5 ;
ganma = 0.9 ;

% Generate a table of Q values (Initial value is generated randomly.)
Q_table = [ rand(24,4) ; 0 0 0 0] ;

% Viewing Q-tables and routes before learning
disp("Q-Table and route before learning");
print_Qtable(Q_table);
Routing(Q_table);

% Studying
for Episode = 1 : 300    % This time, 300 generations.
    % Creating a maze (Also put agent at the starting point.) Squares with people is 1 and squares without people is 0
        maze = [1 0 0 0 0; 0 0 0 0 0 ; 0 0 0 0 0 ; 0 0 0 0 0 ; 0 0 0 0 0 ];
        
    
    % definition of epsilon
        epsilon = 1 - (Episode / 301) ;
    
    for t = 1 : 15  % Maximum of 10 actions per generation
        % Derive the transition destination of the selected action from the current position and Q value table.
        % Understand where you were originally
                state = Search_Location(maze) ;
                if state == 25
                    break
                end
            [ act , new_maze ] = Action(maze,Q_table,epsilon);
            
        % The Q value is updated based on the reward obtained by the action.
            
            % Understand where to go
                new_state = Search_Location(new_maze) ;
                
            [Q_table , new_state ] = update_Qvalue(state,new_state,Q_table,act,alpha,ganma,t) ;
            
        maze = new_maze ; 
    end
end

% Viewing Q-tables and routes after learning
disp("Q-Table and route after learning");
print_Qtable(Q_table);
Routing(Q_table);
